comment		*

Algorithm		: DES	( Block Cipher )
Block		: 8 bytes 
KeySize		: 8 bytes ( 64 bits )

Abstract		: 
		
		   Copyright (c) 2000-2004, Future Systems, Inc. / Seoul, Republic of Korea 
		  All Rights Reserved.                                                  
		                                                                         
		 This document contains proprietary and confidential information.  No     
		 parts of this document or the computer program it embodies may be in     
		 any way copied, duplicated, reproduced, translated into a different      
		 programming language, or distributed to any person, company, or          
		 corporation without the prior written consent of Future Systems, Inc.   
		                              Hyo Sun Hwang                              
		                372-2 YangJae B/D 6th Floor, Seoul, Korea                
		                           +82-2-578-0581 (552)      

Usage		:

			push	offset ptrInkey	( 8bytes data to setkey )
			call	des_setkey	( setkey )
			
			push	offset ptrOutdata	( 8bytes encrypt result buffer )
			push	offset ptrIndata	( 8bytes data to encrypt )
			call	des_encrypt	( encrypt )
			
			push	offset ptrOutdata	( 8bytes decrypt result buffer )
			push	offset ptrIndata	( 8bytes data to decrypt )
			call	des_decrypt	( decrypt )
			
Coded by x3chun	( 2004.06.10 )
		( x3chun@korea.com  or  x3chun@hanyang.ac.kr )  ( http://x3chun.ce.ro )
		
comment		*
		               
DES_ENCRYPT	macro	LL,R,S,X

		mov	ebp,R
		xor	ebp,[des_roundkey+X+S*4]	; u
		mov	edx,R
		xor	edx,[des_roundkey+X+S*4+4] ; t
		ror	edx,4
		mov	esi,ebp			; u
		mov	edi,ebp			; u
		mov	ecx,ebp			; u
		shr	esi,2
		and	esi,3fh
		shr	edi,10
		and	edi,3fh
		shr	ecx,18
		and	ecx,3fh
		shr	ebp,26
		and	ebp,3fh
		xor	LL,[des_SPtrans+0*64*4+esi*4]
		xor	LL,[des_SPtrans+2*64*4+edi*4]
		xor	LL,[des_SPtrans+4*64*4+ecx*4]
		xor	LL,[des_SPtrans+6*64*4+ebp*4]
		mov	esi,edx
		mov	edi,edx
		mov	ecx,edx
		shr	esi,2
		and	esi,3fh
		shr	edi,10
		and	edi,3fh
		shr	ecx,18
		and	ecx,3fh
		shr	edx,26
		and	edx,3fh
		xor	LL,[des_SPtrans+1*64*4+esi*4]
		xor	LL,[des_SPtrans+3*64*4+edi*4]
		xor	LL,[des_SPtrans+5*64*4+ecx*4]
		xor	LL,[des_SPtrans+7*64*4+edx*4]
		
endm

des_setkey	proto	:DWORD
des_encrypt	proto	:DWORD, :DWORD
des_decrypt	proto	:DWORD, :DWORD

include		destabs.inc
include		desm.inc

.code

des_encrypt	proc	ptrIndata:DWORD, ptrOutdata:DWORD

		pushad
		mov	esi,[esp+28h]	; ptrIndata
		mov	eax,[esi]		; r
		mov	ebx,[esi+4]	; l
		IP	eax,ebx
		ror	eax,29
		ror	ebx,29
		DES_ENCRYPT          ebx,eax, 0,0
		DES_ENCRYPT          eax,ebx, 2,0
		DES_ENCRYPT          ebx,eax, 4,0
		DES_ENCRYPT          eax,ebx, 6,0
		DES_ENCRYPT          ebx,eax, 8,0
		DES_ENCRYPT          eax,ebx,10,0
		DES_ENCRYPT          ebx,eax,12,0
		DES_ENCRYPT          eax,ebx,14,0
		DES_ENCRYPT          ebx,eax,16,0
		DES_ENCRYPT          eax,ebx,18,0
		DES_ENCRYPT          ebx,eax,20,0
		DES_ENCRYPT          eax,ebx,22,0
		DES_ENCRYPT          ebx,eax,24,0
		DES_ENCRYPT          eax,ebx,26,0
		DES_ENCRYPT          ebx,eax,28,0
		DES_ENCRYPT          eax,ebx,30,0
		ror	eax,3
		ror	ebx,3
		FP	eax,ebx
		mov	edi,[esp+2ch]	; ptrOutdata
		mov	[edi],ebx
		mov	[edi+4],eax
		popad
		ret
		
des_encrypt	endp

des_decrypt	proc	ptrIndata:DWORD, ptrOutdata:DWORD

		pushad
		mov	esi,[esp+28h]	; ptrIndata
		mov	eax,[esi]		; r
		mov	ebx,[esi+4]	; l
		IP	eax,ebx
		ror	eax,29
		ror	ebx,29
		DES_ENCRYPT          ebx,eax,30,0
		DES_ENCRYPT          eax,ebx,28,0
		DES_ENCRYPT          ebx,eax,26,0
		DES_ENCRYPT          eax,ebx,24,0
		DES_ENCRYPT          ebx,eax,22,0
		DES_ENCRYPT          eax,ebx,20,0
		DES_ENCRYPT          ebx,eax,18,0
		DES_ENCRYPT          eax,ebx,16,0
		DES_ENCRYPT          ebx,eax,14,0
		DES_ENCRYPT          eax,ebx,12,0
		DES_ENCRYPT          ebx,eax,10,0
		DES_ENCRYPT          eax,ebx, 8,0
		DES_ENCRYPT          ebx,eax, 6,0
		DES_ENCRYPT          eax,ebx, 4,0
		DES_ENCRYPT          ebx,eax, 2,0
		DES_ENCRYPT          eax,ebx, 0,0
		ror	eax,3
		ror	ebx,3
		FP	eax,ebx
		mov	edi,[esp+2ch]	; ptrOutdata
		mov	[edi],ebx
		mov	[edi+4],eax
		popad
		ret
		
des_decrypt	endp